import{s as Ft,o as yt,n as D}from"../chunks/scheduler.22bf70d2.js";import{S as Ht,i as xt,g as l,s,r as u,A as Ct,h as c,f as r,c as p,j as Lt,u as $,x as f,k as Mt,y as kt,a as i,v as h,d as g,t as _,w as b}from"../chunks/index.59178e06.js";import{T as P}from"../chunks/Tip.75d940ba.js";import{H as T,E as zt}from"../chunks/EditOnGithub.86314611.js";function At(m){let t,d='To switch between the frameworks, we recommend launching code 🤗 <code>accelerate launch</code> passing in the correct config file with <code>--config_file</code>, or passing in the respective arguments directly for <a href="../package_reference/cli#accelerate-launch">FSDP and DeepSpeed</a> .',n,a,S='Example 🤗 Accelerate configurations can be found here for <a href="../usage_guides/deepspeed#accelerate-deepspeed-plugin">DeepSpeed</a> and <a href="../usage_guides/fsdp#how-it-works-out-of-the-box">FSDP</a>, or in the <a href="../usage_guides/explore">example zoo under “Launch Configurations”</a>';return{c(){t=l("p"),t.innerHTML=d,n=s(),a=l("p"),a.innerHTML=S},l(w){t=c(w,"P",{"data-svelte-h":!0}),f(t)!=="svelte-1fsu9gv"&&(t.innerHTML=d),n=p(w),a=c(w,"P",{"data-svelte-h":!0}),f(a)!=="svelte-161p310"&&(a.innerHTML=S)},m(w,v){i(w,t,v),i(w,n,v),i(w,a,v)},p:D,d(w){w&&(r(t),r(n),r(a))}}}function Rt(m){let t,d="This tutorial is for single-node, multi-GPU, scenarios only.";return{c(){t=l("p"),t.textContent=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-fwxblh"&&(t.textContent=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Et(m){let t,d=`To access other DeepSpeed configurations, such as mixed precision settings,
you need to pass in a <code>--deepspeed_config_file</code>, see the <a href="../usage_guides/deepspeed#deepspeed-config-file">documentation</a>.`,n,a,S='DeepSpeed can be also configured via <a href="/docs/accelerate/main/en/package_reference/deepspeed#accelerate.DeepSpeedPlugin">DeepSpeedPlugin</a>, e.g., <code>DeepSpeedPlugin.zero_stage</code> is equivalent of <code>--zero_stage</code>, and <code>DeepSpeedPlugin.hf_ds_config</code> can be used to pass <code>--deepeed_config_file.</code>';return{c(){t=l("p"),t.innerHTML=d,n=s(),a=l("p"),a.innerHTML=S},l(w){t=c(w,"P",{"data-svelte-h":!0}),f(t)!=="svelte-2knlyq"&&(t.innerHTML=d),n=p(w),a=c(w,"P",{"data-svelte-h":!0}),f(a)!=="svelte-unzcs"&&(a.innerHTML=S)},m(w,v){i(w,t,v),i(w,n,v),i(w,a,v)},p:D,d(w){w&&(r(t),r(n),r(a))}}}function Ot(m){let t,d='FSDP can be also configured via <a href="/docs/accelerate/main/en/package_reference/fsdp#accelerate.FullyShardedDataParallelPlugin">FullyShardedDataParallelPlugin</a>, e.g., <code>FullyShardedDataParallelPlugin.sharding_strategy</code> is equivalent of <code>--fsdp_sharding_strategy</code>.';return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-qswb6b"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function qt(m){let t,d="For DeepSpeed Zero3, it is recommended to also pass a <code>--zero3_save_16bit_model true</code>, which conveniently consolidates the model to a single rank and saves; this is the FSDP equivalent of <code>fsdp_state_dict_type: FULL_STATE_DICT</code>.";return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-10s369g"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Ut(m){let t,d="For FSDP set <code>fsdp_backward_prefetch: BACKWARD_PRE</code> for improved throughputs if memory allows.";return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-1ikst8p"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Bt(m){let t,d="For FSDP, whenever setting <code>--fsdp_cpu_ram_efficient_loading true</code>, please also set <code>--fsdp_sync_module_states true</code>, otherwise the model will not load properly.";return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-z7hnrc"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Wt(m){let t,d="For FSDP, simply set <code>fsdp_auto_wrap_policy: TRANSFORMER_BASED_WRAP</code>. With the latest <code>transformers</code> versions, we try our best to figure out the suitable <code>fsdp_transformer_layer_cls_to_wrap</code> for HF transformers models. However, if you get an error regarding it, please specify this.";return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-e91mtj"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Gt(m){let t,d="For FSDP, when using <code>torch.compile</code> please set <code>fsdp_use_orig_params: True</code>.";return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-19ik7r"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Nt(m){let t,d='When using DeepSpeed, set <code>gradient_accumulation_steps: &quot;auto&quot;</code> and <code>gradient_clipping: &quot;auto&quot;</code> to automatically pick up values set in the <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator">Accelerator</a> or <code>TrainingArguments</code> (if using <code>transformers</code>).';return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-1gzgm5a"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Zt(m){let t,d="As a rule of thumb, for stable training with automatic mixed precision, all the trainable parameters have to be in <code>torch.float32</code>.";return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-1cwgh3z"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function jt(m){let t,d="Therefore when using DeepSpeed a small number of GPUs, be aware of potentially significant memory overheads due to the upcasting during preperation.";return{c(){t=l("p"),t.textContent=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-lujn02"&&(t.textContent=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function It(m){let t,d='With FSDP, in the absence of mixed precision, it is possible to operate the <a href="https://pytorch.org/docs/stable/optim.html#module-torch.optim" rel="nofollow"><code>torch.Optimizer</code></a> in low precision <code>torch_dtype</code>, which may be helpful when using small number of GPUs.';return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-13mf04d"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Kt(m){let t,d="With mixed precision, FSDP and DeepSpeed will upcast in the model preparation step (c.f. table above). But do note that FSDP will then save checkpoints in the upcasted precision; Deepspeed may still save low precision checkpoints if <code>--zero3_save_16bit_model</code> is specified.";return{c(){t=l("p"),t.innerHTML=d},l(n){t=c(n,"P",{"data-svelte-h":!0}),f(t)!=="svelte-10znu4u"&&(t.innerHTML=d)},m(n,a){i(n,t,a)},p:D,d(n){n&&r(t)}}}function Vt(m){let t,d,n,a,S,w,v,Qe='🤗 Accelerate offers flexibilty of training frameworks, by integrating two extremely powerful tools for distributed training, namely <a href="../usage_guides/fsdp.md">Pytorch FSDP</a> and <a href="../usage_guides/deepspeed.md">Microsoft DeepSpeed</a>. The aim of this tutorial is to draw parallels, as well as to outline potential differences, to empower the user to switch seamlessly between these two frameworks.',ce,L,fe,M,me,U,ue,B,Xe='Model tensors are split into different GPUs in an attempt to scale up model sizes; this is termed <em>sharding</em> in FSDP, and <em>partitioning</em> in DeepSpeed. FSDP sharding and DeepSpeed ZeRO (partitioning) stages are configured by <code>--fsdp_sharding_strategy</code>, and <code>--zero_stage</code>, respectively.  In particular, FSDP <code>FULL_SHARD</code> maps to DeepSpeed ZeRO stage <code>3</code>; see this <a href="../usage_guides/fsdp#mapping-between-fsdp-sharding-strategies-and-deepspeed-zero-stages">comprehensive mapping between FSDP sharding and DeepSpeed ZeRO settings</a>. The below table summarizes and groups similar settings:',$e,W,Ye='<thead><tr><th>Group</th> <th>Framework</th> <th>Configuration</th> <th>Example</th> <th>Restrictions (if any)</th></tr></thead> <tbody><tr><td>sharding / partitioning</td> <td>FSDP<br/>DeepSpeed</td> <td><code>--fsdp_sharding_strategy</code><br/><code>--zero_stage</code></td> <td><code>1</code> (<code>FULL_SHARD</code>) <br/><code>3</code></td> <td></td></tr> <tr><td>offload</td> <td>FSDP<br/>DeepSpeed</td> <td><code>--fsdp_offload_params</code><br/><code>--offload_param_device</code><br/><code>--offload_optimizer_device</code></td> <td><code>true</code><br/><code>cpu</code><br/><code>cpu</code></td> <td>all or nothing <br/><br/></td></tr> <tr><td>model loading</td> <td>FSDP<br/>DeepSpeed</td> <td><span style="white-space:nowrap;"><code>--fsdp_cpu_ram_efficient_loading</code></span><br/><code>--zero3_init_flag</code></td> <td><code>true</code><br/><code>true</code></td> <td><br/>only ZeRO 3</td></tr> <tr><td>efficient checkpointing</td> <td>FSDP<br/>DeepSpeed</td> <td><code>--fsdp_state_dict_type</code><br/><code>--zero3_save_16bit_model</code></td> <td><code>SHARDED_STATE_DICT</code><br/><code>true</code></td> <td><br/>only ZeRO 3</td></tr> <tr><td>pipeline</td> <td>FSDP<br/><br/>DeepSpeed</td> <td><code>--fsdp_forward_prefetch</code><br/><code>--fsdp_backward_prefetch</code><br/>None</td> <td><code>true</code><br/><code>BACKWARD_PRE</code></td> <td><br/><br/></td></tr> <tr><td>model</td> <td>FSDP<br/><br/>DeepSpeed</td> <td><code>--fsdp_auto_wrap_policy</code><br/><span style="white-space:nowrap;"><code>--fsdp_transformer_layer_cls_to_wrap</code></span><br/>None</td> <td><code>TRANSFORMER_BASED_WRAP</code><br/>&lt;Layer Class&gt;</td> <td><br/>Usually not needed <br/>Transparent to user.</td></tr> <tr><td>parameters summoning</td> <td>FSDP<br/>DeepSpeed</td> <td><code>--fsdp_use_orig_params</code><br/>None</td> <td><code>true</code></td> <td>required for <code>torch.compile</code><br/>Transparent to user</td></tr> <tr><td>parameters syncing</td> <td>FSDP<br/>DeepSpeed</td> <td><code>--fsdp_sync_module_states</code><br/>None</td> <td><code>true</code></td> <td></td></tr> <tr><td>training</td> <td>FSDP<br/>DeepSpeed</td> <td>None<br/><code>--gradient_accumulation_steps</code><br/><code>--gradient_clipping</code></td> <td><br/><code>auto</code><br/><code>auto</code></td> <td>Transparent to user</td></tr></tbody>',he,G,et='For detailed descriptions of the above, refer to <a href="../package_reference/cli#accelerate-launch">🤗 <code>Accelerate</code> launch documentation</a>.',ge,F,_e,y,be,N,we,Z,tt="Do note that while FSDP can be configured via <code>--fsdp_state_dict_type</code> to save either full / sharded checkpoints.",ve,H,Pe,j,De,I,ot='FSDP only allows <em>all-or-nothing</em> offload (i.e., either offload parameters, gradients, and optimizer, or keep them all in GPU), but DeepSpeed can offload parameters and optimizer differently. Furthermore, DeepSpeed also supports <a href="https://www.deepspeed.ai/docs/config-json/#parameter-offloading" rel="nofollow">offloading to NVME</a>.',Se,K,Te,V,nt=`FSDP allows two prefetching configurations <code>--fsdp_forward_prefetch</code> and <code>--fsdp_backward_prefetch</code> to improve overlap of comms / computation at a cost of extra memory, see <a href="https://pytorch.org/docs/stable/fsdp.html" rel="nofollow">FSDP documentation</a>.
For DeepSpeed, the prefetching is always on, and only certain hyperparams like <code>stage3_prefetch_bucket_size</code> <a href="https://www.deepspeed.ai/docs/config-json/#parameter-offloading" rel="nofollow">can be configured for Zero3</a>; 🤗 <code>accelerate</code> will set these hyperparams automatically.`,Le,x,Me,J,Fe,Q,rt="While FSDP require an explicit <code>--fsdp_cpu_ram_efficient_loading true</code> to activate efficient model loading, 🤗 <code>transformers</code> will activate the similar feature whenever DeepSpeed Zero3 is used.",ye,C,He,X,xe,Y,it="FSDP requires an explicit <code>--fsdp_auto_wrap_policy</code> for the algorithm to decide how to schedule the all-gather and reduce-scatter operations. But for DeepSpeed this is transparent to the user.",Ce,k,ke,ee,ze,te,dt='FSDP requires an explicit <code>--fsdp_use_orig_params</code> flag if using <code>torch.compile</code>, see <a href="https://pytorch.org/docs/stable/fsdp.html#module-torch.distributed.fsdp" rel="nofollow">the pytorch documenation</a>. For DeepSpeed this is transparent to the user.',Ae,z,Re,oe,Ee,ne,at="Deepspeed requires explicit <code>--gradient_accumulation_steps</code> and <code>--gradient_clipping</code> flags. For FSDP this is transparent to the user.",Oe,A,qe,re,Ue,ie,st='To discuss the how data precision is handled in both FSDP and Deepspeed, it is instructive to first give a flow of how model parameters are handled in these frameworks. Before the model / optimizer parameters are distributed across GPUs, parameter preparation is involved to first “flatten” them to  one-dimensional <a href="https://pytorch.org/docs/stable/tensors.html#torch-tensor" rel="nofollow"><code>torch.Tensor</code></a>‘s. The implementation of FSDP / DeepSpeed varies in the respect of the <code>dtype</code> in which these “flattened” parameters are stored, and there are ramifications with regards to how <a href="https://pytorch.org/docs/stable/optim.html#module-torch.optim" rel="nofollow"><code>torch.Optimizer</code></a>’s allocate their <code>dtypes</code>‘s. The table below outlines the processes for both frameworks; the “Local” column indicates the process occurring at a per-gpu level, therefore any memory overheads by upcasting should be understood to be amortized by the number of gpus used.',Be,R,We,de,pt='<thead><tr><th>Process</th> <th>Local</th> <th>Framework</th> <th>Details</th></tr></thead> <tbody><tr><td>Loading, i.e., <code>AutoModel.from_pretrained(..., torch_dtype)</code></td> <td></td> <td></td> <td></td></tr> <tr><td>Preparation, i.e., creation of “flat params”</td> <td>✅</td> <td>FSDP<br/>DeepSpeed</td> <td>created in <code>torch_dtype</code>.<br/> disregards <code>torch_dtype</code>, created in <code>float32</code>.</td></tr> <tr><td>Optimizer initialization</td> <td>✅</td> <td>FSDP<br/>DeepSpeed</td> <td>creates parameters in <code>torch_dtype</code><br/> creates parameters in <code>float32</code></td></tr> <tr><td>Training Step, i.e, forward, backward, reduction</td> <td></td> <td>FSDP<br/>DeepSpeed</td> <td>follows <a href="https://pytorch.org/docs/stable/fsdp.html#torch.distributed.fsdp.MixedPrecision" rel="nofollow"><code>MixedPrecision</code></a><br/> follows <code>deepspeed_config_file</code> mixed precision settings.</td></tr> <tr><td>Optimizer (Pre-Step)</td> <td>✅</td> <td>FSDP<br/>DeepSpeed</td> <td>upcasting (if any) to <code>torch_dtype</code><br/>upcasted to <code>float32</code></td></tr> <tr><td>Optimizer (Actual Step)</td> <td>✅</td> <td>FSDP<br/>DeepSpeed</td> <td>occurs in <code>torch_dtype</code> <br/> occurs in <code>float32</code>.</td></tr></tbody>',Ge,E,Ne,O,Ze,q,je,ae,lt="To clarify the above table consider the concrete examples below; the optimizer pre- and actual step combined for brevity. With FSDP it is possible to operate in the two modes shown below, but DeepSpeed can only operate in one.",Ie,se,ct="<thead><tr><th>Framework</th> <th>Model Loading (<code>torch_dtype</code>)</th> <th>Mixed Precision</th> <th>Preparation (Local)</th> <th>Training</th> <th>Optimizer (Local)</th></tr></thead> <tbody><tr><td>FSDP</td> <td>bf16</td> <td>default (none)</td> <td>bf16</td> <td>bf16</td> <td>bf16</td></tr> <tr><td>FSDP</td> <td>bf16</td> <td>bf16</td> <td>fp32</td> <td>bf16</td> <td>fp32</td></tr> <tr><td>DeepSpeed</td> <td>bf16</td> <td>bf16</td> <td>fp32</td> <td>bf16</td> <td>fp32</td></tr></tbody>",Ke,pe,Ve,le,Je;return S=new T({props:{title:"Moving between FSDP And DeepSpeed",local:"moving-between-fsdp-and-deepspeed",headingTag:"h1"}}),L=new P({props:{$$slots:{default:[At]},$$scope:{ctx:m}}}),M=new P({props:{warning:!0,$$slots:{default:[Rt]},$$scope:{ctx:m}}}),U=new T({props:{title:"Configuring Functionalities",local:"configuring-functionalities",headingTag:"h2"}}),F=new P({props:{$$slots:{default:[Et]},$$scope:{ctx:m}}}),y=new P({props:{$$slots:{default:[Ot]},$$scope:{ctx:m}}}),N=new T({props:{title:"Checkpointing",local:"checkpointing",headingTag:"h3"}}),H=new P({props:{$$slots:{default:[qt]},$$scope:{ctx:m}}}),j=new T({props:{title:"Offloading",local:"offloading",headingTag:"h3"}}),K=new T({props:{title:"Prefetching",local:"prefetching",headingTag:"h3"}}),x=new P({props:{$$slots:{default:[Ut]},$$scope:{ctx:m}}}),J=new T({props:{title:"Model Loading",local:"model-loading",headingTag:"h3"}}),C=new P({props:{$$slots:{default:[Bt]},$$scope:{ctx:m}}}),X=new T({props:{title:"Model",local:"model",headingTag:"h3"}}),k=new P({props:{$$slots:{default:[Wt]},$$scope:{ctx:m}}}),ee=new T({props:{title:"Parameters Summoning",local:"parameters-summoning",headingTag:"h3"}}),z=new P({props:{$$slots:{default:[Gt]},$$scope:{ctx:m}}}),oe=new T({props:{title:"Training",local:"training",headingTag:"h2"}}),A=new P({props:{$$slots:{default:[Nt]},$$scope:{ctx:m}}}),re=new T({props:{title:"On Differences in Data Precision Handling",local:"on-differences-in-data-precision-handling",headingTag:"h2"}}),R=new P({props:{$$slots:{default:[Zt]},$$scope:{ctx:m}}}),E=new P({props:{warning:!0,$$slots:{default:[jt]},$$scope:{ctx:m}}}),O=new P({props:{$$slots:{default:[It]},$$scope:{ctx:m}}}),q=new P({props:{warning:!0,$$slots:{default:[Kt]},$$scope:{ctx:m}}}),pe=new zt({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/concept_guides/fsdp_and_deepspeed.md"}}),{c(){t=l("meta"),d=s(),n=l("p"),a=s(),u(S.$$.fragment),w=s(),v=l("p"),v.innerHTML=Qe,ce=s(),u(L.$$.fragment),fe=s(),u(M.$$.fragment),me=s(),u(U.$$.fragment),ue=s(),B=l("p"),B.innerHTML=Xe,$e=s(),W=l("table"),W.innerHTML=Ye,he=s(),G=l("p"),G.innerHTML=et,ge=s(),u(F.$$.fragment),_e=s(),u(y.$$.fragment),be=s(),u(N.$$.fragment),we=s(),Z=l("p"),Z.innerHTML=tt,ve=s(),u(H.$$.fragment),Pe=s(),u(j.$$.fragment),De=s(),I=l("p"),I.innerHTML=ot,Se=s(),u(K.$$.fragment),Te=s(),V=l("p"),V.innerHTML=nt,Le=s(),u(x.$$.fragment),Me=s(),u(J.$$.fragment),Fe=s(),Q=l("p"),Q.innerHTML=rt,ye=s(),u(C.$$.fragment),He=s(),u(X.$$.fragment),xe=s(),Y=l("p"),Y.innerHTML=it,Ce=s(),u(k.$$.fragment),ke=s(),u(ee.$$.fragment),ze=s(),te=l("p"),te.innerHTML=dt,Ae=s(),u(z.$$.fragment),Re=s(),u(oe.$$.fragment),Ee=s(),ne=l("p"),ne.innerHTML=at,Oe=s(),u(A.$$.fragment),qe=s(),u(re.$$.fragment),Ue=s(),ie=l("p"),ie.innerHTML=st,Be=s(),u(R.$$.fragment),We=s(),de=l("table"),de.innerHTML=pt,Ge=s(),u(E.$$.fragment),Ne=s(),u(O.$$.fragment),Ze=s(),u(q.$$.fragment),je=s(),ae=l("p"),ae.textContent=lt,Ie=s(),se=l("table"),se.innerHTML=ct,Ke=s(),u(pe.$$.fragment),Ve=s(),le=l("p"),this.h()},l(e){const o=Ct("svelte-u9bgzb",document.head);t=c(o,"META",{name:!0,content:!0}),o.forEach(r),d=p(e),n=c(e,"P",{}),Lt(n).forEach(r),a=p(e),$(S.$$.fragment,e),w=p(e),v=c(e,"P",{"data-svelte-h":!0}),f(v)!=="svelte-6rapxg"&&(v.innerHTML=Qe),ce=p(e),$(L.$$.fragment,e),fe=p(e),$(M.$$.fragment,e),me=p(e),$(U.$$.fragment,e),ue=p(e),B=c(e,"P",{"data-svelte-h":!0}),f(B)!=="svelte-5g2whc"&&(B.innerHTML=Xe),$e=p(e),W=c(e,"TABLE",{"data-svelte-h":!0}),f(W)!=="svelte-161intz"&&(W.innerHTML=Ye),he=p(e),G=c(e,"P",{"data-svelte-h":!0}),f(G)!=="svelte-40z403"&&(G.innerHTML=et),ge=p(e),$(F.$$.fragment,e),_e=p(e),$(y.$$.fragment,e),be=p(e),$(N.$$.fragment,e),we=p(e),Z=c(e,"P",{"data-svelte-h":!0}),f(Z)!=="svelte-9rvkee"&&(Z.innerHTML=tt),ve=p(e),$(H.$$.fragment,e),Pe=p(e),$(j.$$.fragment,e),De=p(e),I=c(e,"P",{"data-svelte-h":!0}),f(I)!=="svelte-1u64gx1"&&(I.innerHTML=ot),Se=p(e),$(K.$$.fragment,e),Te=p(e),V=c(e,"P",{"data-svelte-h":!0}),f(V)!=="svelte-ho6cne"&&(V.innerHTML=nt),Le=p(e),$(x.$$.fragment,e),Me=p(e),$(J.$$.fragment,e),Fe=p(e),Q=c(e,"P",{"data-svelte-h":!0}),f(Q)!=="svelte-ym6k6d"&&(Q.innerHTML=rt),ye=p(e),$(C.$$.fragment,e),He=p(e),$(X.$$.fragment,e),xe=p(e),Y=c(e,"P",{"data-svelte-h":!0}),f(Y)!=="svelte-w79l38"&&(Y.innerHTML=it),Ce=p(e),$(k.$$.fragment,e),ke=p(e),$(ee.$$.fragment,e),ze=p(e),te=c(e,"P",{"data-svelte-h":!0}),f(te)!=="svelte-mzwi2o"&&(te.innerHTML=dt),Ae=p(e),$(z.$$.fragment,e),Re=p(e),$(oe.$$.fragment,e),Ee=p(e),ne=c(e,"P",{"data-svelte-h":!0}),f(ne)!=="svelte-kcq705"&&(ne.innerHTML=at),Oe=p(e),$(A.$$.fragment,e),qe=p(e),$(re.$$.fragment,e),Ue=p(e),ie=c(e,"P",{"data-svelte-h":!0}),f(ie)!=="svelte-1sjps1u"&&(ie.innerHTML=st),Be=p(e),$(R.$$.fragment,e),We=p(e),de=c(e,"TABLE",{"data-svelte-h":!0}),f(de)!=="svelte-hexlxn"&&(de.innerHTML=pt),Ge=p(e),$(E.$$.fragment,e),Ne=p(e),$(O.$$.fragment,e),Ze=p(e),$(q.$$.fragment,e),je=p(e),ae=c(e,"P",{"data-svelte-h":!0}),f(ae)!=="svelte-12wucry"&&(ae.textContent=lt),Ie=p(e),se=c(e,"TABLE",{"data-svelte-h":!0}),f(se)!=="svelte-1j56a62"&&(se.innerHTML=ct),Ke=p(e),$(pe.$$.fragment,e),Ve=p(e),le=c(e,"P",{}),Lt(le).forEach(r),this.h()},h(){Mt(t,"name","hf:doc:metadata"),Mt(t,"content",Jt)},m(e,o){kt(document.head,t),i(e,d,o),i(e,n,o),i(e,a,o),h(S,e,o),i(e,w,o),i(e,v,o),i(e,ce,o),h(L,e,o),i(e,fe,o),h(M,e,o),i(e,me,o),h(U,e,o),i(e,ue,o),i(e,B,o),i(e,$e,o),i(e,W,o),i(e,he,o),i(e,G,o),i(e,ge,o),h(F,e,o),i(e,_e,o),h(y,e,o),i(e,be,o),h(N,e,o),i(e,we,o),i(e,Z,o),i(e,ve,o),h(H,e,o),i(e,Pe,o),h(j,e,o),i(e,De,o),i(e,I,o),i(e,Se,o),h(K,e,o),i(e,Te,o),i(e,V,o),i(e,Le,o),h(x,e,o),i(e,Me,o),h(J,e,o),i(e,Fe,o),i(e,Q,o),i(e,ye,o),h(C,e,o),i(e,He,o),h(X,e,o),i(e,xe,o),i(e,Y,o),i(e,Ce,o),h(k,e,o),i(e,ke,o),h(ee,e,o),i(e,ze,o),i(e,te,o),i(e,Ae,o),h(z,e,o),i(e,Re,o),h(oe,e,o),i(e,Ee,o),i(e,ne,o),i(e,Oe,o),h(A,e,o),i(e,qe,o),h(re,e,o),i(e,Ue,o),i(e,ie,o),i(e,Be,o),h(R,e,o),i(e,We,o),i(e,de,o),i(e,Ge,o),h(E,e,o),i(e,Ne,o),h(O,e,o),i(e,Ze,o),h(q,e,o),i(e,je,o),i(e,ae,o),i(e,Ie,o),i(e,se,o),i(e,Ke,o),h(pe,e,o),i(e,Ve,o),i(e,le,o),Je=!0},p(e,[o]){const ft={};o&2&&(ft.$$scope={dirty:o,ctx:e}),L.$set(ft);const mt={};o&2&&(mt.$$scope={dirty:o,ctx:e}),M.$set(mt);const ut={};o&2&&(ut.$$scope={dirty:o,ctx:e}),F.$set(ut);const $t={};o&2&&($t.$$scope={dirty:o,ctx:e}),y.$set($t);const ht={};o&2&&(ht.$$scope={dirty:o,ctx:e}),H.$set(ht);const gt={};o&2&&(gt.$$scope={dirty:o,ctx:e}),x.$set(gt);const _t={};o&2&&(_t.$$scope={dirty:o,ctx:e}),C.$set(_t);const bt={};o&2&&(bt.$$scope={dirty:o,ctx:e}),k.$set(bt);const wt={};o&2&&(wt.$$scope={dirty:o,ctx:e}),z.$set(wt);const vt={};o&2&&(vt.$$scope={dirty:o,ctx:e}),A.$set(vt);const Pt={};o&2&&(Pt.$$scope={dirty:o,ctx:e}),R.$set(Pt);const Dt={};o&2&&(Dt.$$scope={dirty:o,ctx:e}),E.$set(Dt);const St={};o&2&&(St.$$scope={dirty:o,ctx:e}),O.$set(St);const Tt={};o&2&&(Tt.$$scope={dirty:o,ctx:e}),q.$set(Tt)},i(e){Je||(g(S.$$.fragment,e),g(L.$$.fragment,e),g(M.$$.fragment,e),g(U.$$.fragment,e),g(F.$$.fragment,e),g(y.$$.fragment,e),g(N.$$.fragment,e),g(H.$$.fragment,e),g(j.$$.fragment,e),g(K.$$.fragment,e),g(x.$$.fragment,e),g(J.$$.fragment,e),g(C.$$.fragment,e),g(X.$$.fragment,e),g(k.$$.fragment,e),g(ee.$$.fragment,e),g(z.$$.fragment,e),g(oe.$$.fragment,e),g(A.$$.fragment,e),g(re.$$.fragment,e),g(R.$$.fragment,e),g(E.$$.fragment,e),g(O.$$.fragment,e),g(q.$$.fragment,e),g(pe.$$.fragment,e),Je=!0)},o(e){_(S.$$.fragment,e),_(L.$$.fragment,e),_(M.$$.fragment,e),_(U.$$.fragment,e),_(F.$$.fragment,e),_(y.$$.fragment,e),_(N.$$.fragment,e),_(H.$$.fragment,e),_(j.$$.fragment,e),_(K.$$.fragment,e),_(x.$$.fragment,e),_(J.$$.fragment,e),_(C.$$.fragment,e),_(X.$$.fragment,e),_(k.$$.fragment,e),_(ee.$$.fragment,e),_(z.$$.fragment,e),_(oe.$$.fragment,e),_(A.$$.fragment,e),_(re.$$.fragment,e),_(R.$$.fragment,e),_(E.$$.fragment,e),_(O.$$.fragment,e),_(q.$$.fragment,e),_(pe.$$.fragment,e),Je=!1},d(e){e&&(r(d),r(n),r(a),r(w),r(v),r(ce),r(fe),r(me),r(ue),r(B),r($e),r(W),r(he),r(G),r(ge),r(_e),r(be),r(we),r(Z),r(ve),r(Pe),r(De),r(I),r(Se),r(Te),r(V),r(Le),r(Me),r(Fe),r(Q),r(ye),r(He),r(xe),r(Y),r(Ce),r(ke),r(ze),r(te),r(Ae),r(Re),r(Ee),r(ne),r(Oe),r(qe),r(Ue),r(ie),r(Be),r(We),r(de),r(Ge),r(Ne),r(Ze),r(je),r(ae),r(Ie),r(se),r(Ke),r(Ve),r(le)),r(t),b(S,e),b(L,e),b(M,e),b(U,e),b(F,e),b(y,e),b(N,e),b(H,e),b(j,e),b(K,e),b(x,e),b(J,e),b(C,e),b(X,e),b(k,e),b(ee,e),b(z,e),b(oe,e),b(A,e),b(re,e),b(R,e),b(E,e),b(O,e),b(q,e),b(pe,e)}}}const Jt='{"title":"Moving between FSDP And DeepSpeed","local":"moving-between-fsdp-and-deepspeed","sections":[{"title":"Configuring Functionalities","local":"configuring-functionalities","sections":[{"title":"Checkpointing","local":"checkpointing","sections":[],"depth":3},{"title":"Offloading","local":"offloading","sections":[],"depth":3},{"title":"Prefetching","local":"prefetching","sections":[],"depth":3},{"title":"Model Loading","local":"model-loading","sections":[],"depth":3},{"title":"Model","local":"model","sections":[],"depth":3},{"title":"Parameters Summoning","local":"parameters-summoning","sections":[],"depth":3}],"depth":2},{"title":"Training","local":"training","sections":[],"depth":2},{"title":"On Differences in Data Precision Handling","local":"on-differences-in-data-precision-handling","sections":[],"depth":2}],"depth":1}';function Qt(m){return yt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class oo extends Ht{constructor(t){super(),xt(this,t,Qt,Vt,Ft,{})}}export{oo as component};
